diff --git a/base/server/src/engine/pkiparser.py b/base/server/src/engine/pkiparser.py
index 34078020455dec56c40c02b0c7c51febce5dabeb..bc868d61bc59b4b9aaa8d687eb74f071d78162a7 100644
--- a/base/server/src/engine/pkiparser.py
+++ b/base/server/src/engine/pkiparser.py
@@ -798,11 +801,11 @@ class PKIConfigParser:
                     "-TLS_RSA_EXPORT1024_WITH_RC4_56_SHA," +\
                     "-TLS_ECDH_ECDSA_WITH_AES_256_CBC_SHA," +\
                     "+TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA"
-                config.pki_master_dict['TOMCAT_SSL_OPTIONS_SLOT'] =\
+                self.pki_master_dict['TOMCAT_SSL_OPTIONS_SLOT'] =\
                     "ssl2=true," +\
                     "ssl3=true," +\
                     "tls=true"
-                config.pki_master_dict['TOMCAT_TLS_CIPHERS_SLOT'] =\
+                self.pki_master_dict['TOMCAT_TLS_CIPHERS_SLOT'] =\
                     "-TLS_ECDH_ECDSA_WITH_AES_128_CBC_SHA," +\
                     "-TLS_ECDH_ECDSA_WITH_3DES_EDE_CBC_SHA," +\
                     "+TLS_ECDH_RSA_WITH_3DES_EDE_CBC_SHA," +\
@@ -824,56 +827,56 @@ class PKIConfigParser:
                     "+TLS_DHE_RSA_WITH_3DES_EDE_CBC_SHA," +\
                     "+TLS_DHE_RSA_WITH_AES_128_CBC_SHA," +\
                     "+TLS_DHE_RSA_WITH_AES_256_CBC_SHA"
-                if config.pki_master_dict['pki_subsystem'] == "CA":
-                    config.pki_master_dict['PKI_ENABLE_RANDOM_SERIAL_NUMBERS']=\
-                        config.pki_master_dict\
+                if self.pki_master_dict['pki_subsystem'] == "CA":
+                    self.pki_master_dict['PKI_ENABLE_RANDOM_SERIAL_NUMBERS']=\
+                        self.pki_master_dict\
                         ['pki_random_serial_numbers_enable'].lower()
             # Shared Apache/Tomcat NSS security database name/value pairs
-            config.pki_master_dict['pki_shared_pfile'] =\
+            self.pki_master_dict['pki_shared_pfile'] =\
                 os.path.join(
-                    config.pki_master_dict['pki_instance_configuration_path'],
+                    self.pki_master_dict['pki_instance_configuration_path'],
                     "pfile")
-            config.pki_master_dict['pki_shared_password_conf'] =\
+            self.pki_master_dict['pki_shared_password_conf'] =\
                 os.path.join(
-                    config.pki_master_dict['pki_instance_configuration_path'],
+                    self.pki_master_dict['pki_instance_configuration_path'],
                     "password.conf")
-            config.pki_master_dict['pki_cert_database'] =\
-                os.path.join(config.pki_master_dict['pki_database_path'],
+            self.pki_master_dict['pki_cert_database'] =\
+                os.path.join(self.pki_master_dict['pki_database_path'],
                              "cert8.db")
-            config.pki_master_dict['pki_key_database'] =\
-                os.path.join(config.pki_master_dict['pki_database_path'],
+            self.pki_master_dict['pki_key_database'] =\
+                os.path.join(self.pki_master_dict['pki_database_path'],
                              "key3.db")
-            config.pki_master_dict['pki_secmod_database'] =\
-                os.path.join(config.pki_master_dict['pki_database_path'],
+            self.pki_master_dict['pki_secmod_database'] =\
+                os.path.join(self.pki_master_dict['pki_database_path'],
                              "secmod.db")
-            config.pki_master_dict['pki_self_signed_token'] = "internal"
-            config.pki_master_dict['pki_self_signed_nickname'] =\
-                config.pki_master_dict['pki_ssl_server_nickname']
-            config.pki_master_dict['pki_self_signed_subject'] =\
-                "cn=" + config.pki_master_dict['pki_hostname'] + "," +\
-                "o=" + config.pki_master_dict['pki_certificate_timestamp']
-            config.pki_master_dict['pki_self_signed_serial_number'] = 0
-            config.pki_master_dict['pki_self_signed_validity_period'] = 12
-            config.pki_master_dict['pki_self_signed_issuer_name'] =\
-                "cn=" + config.pki_master_dict['pki_hostname'] + "," +\
-                "o=" + config.pki_master_dict['pki_certificate_timestamp']
-            config.pki_master_dict['pki_self_signed_trustargs'] = "CTu,CTu,CTu"
-            config.pki_master_dict['pki_self_signed_noise_file'] =\
+            self.pki_master_dict['pki_self_signed_token'] = "internal"
+            self.pki_master_dict['pki_self_signed_nickname'] =\
+                self.pki_master_dict['pki_ssl_server_nickname']
+            self.pki_master_dict['pki_self_signed_subject'] =\
+                "cn=" + self.pki_master_dict['pki_hostname'] + "," +\
+                "o=" + self.pki_master_dict['pki_certificate_timestamp']
+            self.pki_master_dict['pki_self_signed_serial_number'] = 0
+            self.pki_master_dict['pki_self_signed_validity_period'] = 12
+            self.pki_master_dict['pki_self_signed_issuer_name'] =\
+                "cn=" + self.pki_master_dict['pki_hostname'] + "," +\
+                "o=" + self.pki_master_dict['pki_certificate_timestamp']
+            self.pki_master_dict['pki_self_signed_trustargs'] = "CTu,CTu,CTu"
+            self.pki_master_dict['pki_self_signed_noise_file'] =\
                 os.path.join(
-                    config.pki_master_dict['pki_subsystem_configuration_path'],
+                    self.pki_master_dict['pki_subsystem_configuration_path'],
                     "noise")
-            config.pki_master_dict['pki_self_signed_noise_bytes'] = 1024
+            self.pki_master_dict['pki_self_signed_noise_bytes'] = 1024
             # Shared Apache/Tomcat NSS security database convenience symbolic links
-            config.pki_master_dict\
+            self.pki_master_dict\
             ['pki_subsystem_configuration_password_conf_link'] =\
                 os.path.join(
-                    config.pki_master_dict['pki_subsystem_configuration_path'],
+                    self.pki_master_dict['pki_subsystem_configuration_path'],
                     "password.conf")
 
-            if not len(config.pki_master_dict['pki_client_database_password']):
+            if not len(self.pki_master_dict['pki_client_database_password']):
                 # use randomly generated client 'pin'
-                config.pki_master_dict['pki_client_database_password'] =\
-                    str(config.pki_master_dict['pki_client_pin'])
+                self.pki_master_dict['pki_client_database_password'] =\
+                    str(self.pki_master_dict['pki_client_pin'])
 
             # Configuration scriptlet
             # 'Security Domain' Configuration name/value pairs
@@ -888,66 +891,66 @@ class PKIConfigParser:
             #
             #     The following variables are defined below:
             #
-            #         config.pki_master_dict['pki_security_domain_type']
-            #         config.pki_master_dict['pki_security_domain_uri']
+            #         self.pki_master_dict['pki_security_domain_type']
+            #         self.pki_master_dict['pki_security_domain_uri']
             #
             #     The following variables are established via the specified PKI
             #     deployment configuration file and are NOT redefined below:
             #
-            #         config.pki_master_dict['pki_clone_pkcs12_password']
-            #         config.pki_master_dict['pki_security_domain_password']
-            #         config.pki_master_dict['pki_token_password']
-            #         config.pki_master_dict['pki_clone_pkcs12_path']
-            #         config.pki_master_dict['pki_clone_uri']
-            #         config.pki_master_dict['pki_security_domain_https_port']
-            #         config.pki_master_dict['pki_token_name']
+            #         self.pki_master_dict['pki_clone_pkcs12_password']
+            #         self.pki_master_dict['pki_security_domain_password']
+            #         self.pki_master_dict['pki_token_password']
+            #         self.pki_master_dict['pki_clone_pkcs12_path']
+            #         self.pki_master_dict['pki_clone_uri']
+            #         self.pki_master_dict['pki_security_domain_https_port']
+            #         self.pki_master_dict['pki_token_name']
             #
             #     The following variables are established via the specified PKI
             #     deployment configuration file and potentially overridden below:
             #
-            #         config.pki_master_dict['pki_security_domain_user']
-            #         config.pki_master_dict['pki_issuing_ca']
+            #         self.pki_master_dict['pki_security_domain_user']
+            #         self.pki_master_dict['pki_issuing_ca']
             #
 
             # if security domain user is not defined
-            if not len(config.pki_master_dict['pki_security_domain_user']):
+            if not len(self.pki_master_dict['pki_security_domain_user']):
 
                 # use the CA admin uid if it's defined
                 if self.pki_config.has_option('CA', 'pki_admin_uid') and\
                     len(self.pki_config.get('CA', 'pki_admin_uid')) > 0:
-                    config.pki_master_dict['pki_security_domain_user'] =\
+                    self.pki_master_dict['pki_security_domain_user'] =\
                         self.pki_config.get('CA', 'pki_admin_uid')
 
                 # or use the Default admin uid if it's defined
                 elif self.pki_config.has_option('DEFAULT', 'pki_admin_uid') and\
                     len(self.pki_config.get('DEFAULT', 'pki_admin_uid')) > 0:
-                    config.pki_master_dict['pki_security_domain_user'] =\
+                    self.pki_master_dict['pki_security_domain_user'] =\
                         self.pki_config.get('DEFAULT', 'pki_admin_uid')
 
                 # otherwise use the default CA admin uid
                 else:
-                    config.pki_master_dict['pki_security_domain_user'] = "caadmin"
+                    self.pki_master_dict['pki_security_domain_user'] = "caadmin"
 
             if config.pki_subsystem != "CA" or\
-               config.str2bool(config.pki_master_dict['pki_clone']) or\
-               config.str2bool(config.pki_master_dict['pki_subordinate']):
+               config.str2bool(self.pki_master_dict['pki_clone']) or\
+               config.str2bool(self.pki_master_dict['pki_subordinate']):
                 # PKI KRA, PKI OCSP, PKI RA, PKI TKS, PKI TPS,
                 # CA Clone, KRA Clone, OCSP Clone, TKS Clone, TPS Clone, or
                 # Subordinate CA
-                config.pki_master_dict['pki_security_domain_type'] = "existing"
-                config.pki_master_dict['pki_security_domain_uri'] =\
+                self.pki_master_dict['pki_security_domain_type'] = "existing"
+                self.pki_master_dict['pki_security_domain_uri'] =\
                     "https" + "://" +\
-                    config.pki_master_dict['pki_security_domain_hostname'] + ":" +\
-                    config.pki_master_dict['pki_security_domain_https_port']
+                    self.pki_master_dict['pki_security_domain_hostname'] + ":" +\
+                    self.pki_master_dict['pki_security_domain_https_port']
 
-            elif config.str2bool(config.pki_master_dict['pki_external']):
+            elif config.str2bool(self.pki_master_dict['pki_external']):
                 # External CA
-                config.pki_master_dict['pki_security_domain_type'] = "new"
-                if not len(config.pki_master_dict['pki_issuing_ca']):
-                    config.pki_master_dict['pki_issuing_ca'] = "External CA"
+                self.pki_master_dict['pki_security_domain_type'] = "new"
+                if not len(self.pki_master_dict['pki_issuing_ca']):
+                    self.pki_master_dict['pki_issuing_ca'] = "External CA"
             else:
                 # PKI CA
-                config.pki_master_dict['pki_security_domain_type'] = "new"
+                self.pki_master_dict['pki_security_domain_type'] = "new"
 
             # 'External CA' Configuration name/value pairs
             #
@@ -956,10 +959,10 @@ class PKIConfigParser:
             #     The following variables are established via the specified PKI
             #     deployment configuration file and are NOT redefined below:
             #
-            #        config.pki_master_dict['pki_external_ca_cert_chain_path']
-            #        config.pki_master_dict['pki_external_ca_cert_path']
-            #        config.pki_master_dict['pki_external_csr_path']
-            #        config.pki_master_dict['pki_external_step_two']
+            #        self.pki_master_dict['pki_external_ca_cert_chain_path']
+            #        self.pki_master_dict['pki_external_ca_cert_path']
+            #        self.pki_master_dict['pki_external_csr_path']
+            #        self.pki_master_dict['pki_external_step_two']
             #
 
             # 'Backup' Configuration name/value pairs
@@ -972,52 +975,52 @@ class PKIConfigParser:
             #     The following variables are established via the specified PKI
             #     deployment configuration file and are NOT redefined below:
             #
-            #        config.pki_master_dict['pki_backup_password']
-            #        config.pki_master_dict['pki_backup_keys']
+            #        self.pki_master_dict['pki_backup_password']
+            #        self.pki_master_dict['pki_backup_keys']
             #
-            if config.str2bool(config.pki_master_dict['pki_backup_keys']):
+            if config.str2bool(self.pki_master_dict['pki_backup_keys']):
                 # NOTE:  ALWAYS store the PKCS #12 backup keys file
                 #        in with the NSS "server" security databases
-                config.pki_master_dict['pki_backup_keys_p12'] =\
-                    config.pki_master_dict['pki_database_path'] + "/" +\
-                    config.pki_master_dict['pki_subsystem'].lower() + "_" +\
+                self.pki_master_dict['pki_backup_keys_p12'] =\
+                    self.pki_master_dict['pki_database_path'] + "/" +\
+                    self.pki_master_dict['pki_subsystem'].lower() + "_" +\
                     "backup" + "_" + "keys" + "." + "p12"
 
-            config.pki_master_dict['pki_admin_profile_id'] = "caAdminCert"
+            self.pki_master_dict['pki_admin_profile_id'] = "caAdminCert"
 
-            if not 'pki_import_admin_cert' in config.pki_master_dict:
-                config.pki_master_dict['pki_import_admin_cert'] = 'false'
+            if not 'pki_import_admin_cert' in self.pki_master_dict:
+                self.pki_master_dict['pki_import_admin_cert'] = 'false'
 
-            config.pki_master_dict['pki_ca_signing_tag'] = "signing"
-            if config.pki_master_dict['pki_subsystem'] == "CA":
-                config.pki_master_dict['pki_ocsp_signing_tag'] = "ocsp_signing"
-            elif config.pki_master_dict['pki_subsystem'] == "OCSP":
-                config.pki_master_dict['pki_ocsp_signing_tag'] = "signing"
-            config.pki_master_dict['pki_ssl_server_tag'] = "sslserver"
-            config.pki_master_dict['pki_subsystem_tag'] = "subsystem"
-            config.pki_master_dict['pki_audit_signing_tag'] = "audit_signing"
-            config.pki_master_dict['pki_transport_tag'] = "transport"
-            config.pki_master_dict['pki_storage_tag'] = "storage"
+            self.pki_master_dict['pki_ca_signing_tag'] = "signing"
+            if self.pki_master_dict['pki_subsystem'] == "CA":
+                self.pki_master_dict['pki_ocsp_signing_tag'] = "ocsp_signing"
+            elif self.pki_master_dict['pki_subsystem'] == "OCSP":
+                self.pki_master_dict['pki_ocsp_signing_tag'] = "signing"
+            self.pki_master_dict['pki_ssl_server_tag'] = "sslserver"
+            self.pki_master_dict['pki_subsystem_tag'] = "subsystem"
+            self.pki_master_dict['pki_audit_signing_tag'] = "audit_signing"
+            self.pki_master_dict['pki_transport_tag'] = "transport"
+            self.pki_master_dict['pki_storage_tag'] = "storage"
 
             # Finalization name/value pairs
-            config.pki_master_dict['pki_default_deployment_cfg_replica'] =\
-                os.path.join(config.pki_master_dict['pki_subsystem_registry_path'],
+            self.pki_master_dict['pki_default_deployment_cfg_replica'] =\
+                os.path.join(self.pki_master_dict['pki_subsystem_registry_path'],
                              config.DEFAULT_DEPLOYMENT_CONFIGURATION)
-            config.pki_master_dict['pki_user_deployment_cfg_replica'] =\
-                os.path.join(config.pki_master_dict['pki_subsystem_registry_path'],
+            self.pki_master_dict['pki_user_deployment_cfg_replica'] =\
+                os.path.join(self.pki_master_dict['pki_subsystem_registry_path'],
                              config.USER_DEPLOYMENT_CONFIGURATION)
-            config.pki_master_dict['pki_user_deployment_cfg_spawn_archive'] =\
-                config.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
+            self.pki_master_dict['pki_user_deployment_cfg_spawn_archive'] =\
+                self.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
                 "spawn" + "_" +\
                 config.USER_DEPLOYMENT_CONFIGURATION + "." +\
-                config.pki_master_dict['pki_timestamp']
-            config.pki_master_dict['pki_manifest'] =\
-                config.pki_master_dict['pki_subsystem_registry_path'] + "/" +\
+                self.pki_master_dict['pki_timestamp']
+            self.pki_master_dict['pki_manifest'] =\
+                self.pki_master_dict['pki_subsystem_registry_path'] + "/" +\
                 "manifest"
-            config.pki_master_dict['pki_manifest_spawn_archive'] =\
-                config.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
+            self.pki_master_dict['pki_manifest_spawn_archive'] =\
+                self.pki_master_dict['pki_subsystem_archive_log_path'] + "/" +\
                 "spawn" + "_" + "manifest" + "." +\
-                config.pki_master_dict['pki_timestamp']
+                self.pki_master_dict['pki_timestamp']
             # Construct the configuration URL containing the one-time pin
             # and add this to the "sensitive" key value pairs read in from
             # the configuration file
@@ -1026,28 +1029,28 @@ class PKIConfigParser:
             #        parameter that may be stored in a log file and displayed
             #        to the screen.
             #
-            config.pki_master_dict['pki_configuration_url'] =\
+            self.pki_master_dict['pki_configuration_url'] =\
                 "https://{}:{}/{}/{}?pin={}".format(
-                    config.pki_master_dict['pki_hostname'],
-                    config.pki_master_dict['pki_https_port'],
-                    config.pki_master_dict['pki_subsystem'].lower(),
+                    self.pki_master_dict['pki_hostname'],
+                    self.pki_master_dict['pki_https_port'],
+                    self.pki_master_dict['pki_subsystem'].lower(),
                     "admin/console/config/login",
-                    config.pki_master_dict['pki_one_time_pin'])
+                    self.pki_master_dict['pki_one_time_pin'])
             # Compose this "systemd" execution management command
-            if config.pki_master_dict['pki_subsystem'] in\
+            if self.pki_master_dict['pki_subsystem'] in\
                config.PKI_APACHE_SUBSYSTEMS:
-                config.pki_master_dict['pki_registry_initscript_command'] =\
+                self.pki_master_dict['pki_registry_initscript_command'] =\
                     "systemctl" + " " +\
                     "restart" + " " +\
                     "pki-apached" + "@" +\
-                    config.pki_master_dict['pki_instance_name'] + "." + "service"
-            elif config.pki_master_dict['pki_subsystem'] in\
+                    self.pki_master_dict['pki_instance_name'] + "." + "service"
+            elif self.pki_master_dict['pki_subsystem'] in\
                  config.PKI_TOMCAT_SUBSYSTEMS:
-                config.pki_master_dict['pki_registry_initscript_command'] =\
+                self.pki_master_dict['pki_registry_initscript_command'] =\
                     "systemctl" + " " +\
                     "restart" + " " +\
                     "pki-tomcatd" + "@" +\
-                    config.pki_master_dict['pki_instance_name'] + "." + "service"
+                    self.pki_master_dict['pki_instance_name'] + "." + "service"
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
                                  extra=config.PKI_INDENTATION_LEVEL_2)
@@ -1064,16 +1067,15 @@ class PKIConfigParser:
            the appropriate PKI slots dictionary"""
         rv = 0
         try:
-            config.pki_slots_dict = dict()
             parser = ConfigParser.ConfigParser()
             # Make keys case-sensitive!
             parser.optionxform = str
             parser.read(config.PKI_DEPLOYMENT_SLOTS_CONFIGURATION_FILE)
             # Slots configuration file name/value pairs
             if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
-                config.pki_slots_dict = dict(parser._sections['Apache'])
+                self.pki_slots_dict = dict(parser._sections['Apache'])
             elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
-                config.pki_slots_dict = dict(parser._sections['Tomcat'])
+                self.pki_slots_dict = dict(parser._sections['Tomcat'])
         except ConfigParser.ParsingError, err:
             rv = err
         return rv
diff --git a/base/server/src/pkidestroy b/base/server/src/pkidestroy
index 1e3f7f5788840db73c612d194931d17c45addaf8..16e2b6654f72f49410132444744fb2255d9dcd44 100755
--- a/base/server/src/pkidestroy
+++ b/base/server/src/pkidestroy
@@ -40,6 +40,7 @@ try:
     from pki.deployment.pkiparser import PKIConfigParser
     from pki.deployment import pkilogging
     from pki.deployment import pkimessages as log
+    import pki.deployment.pkihelper as util
 except ImportError:
     print >> sys.stderr, """\
 There was a problem importing one of the required Python modules. The
@@ -229,29 +230,30 @@ def main(argv):
 
     # Combine the various sectional dictionaries into a PKI master dictionary
     parser.compose_pki_master_dictionary()
-    config.pki_master_dict['pki_destroy_log'] = config.pki_log_dir + "/" +\
+    parser.pki_master_dict['pki_destroy_log'] = config.pki_log_dir + "/" +\
                                                 config.pki_log_name
     config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
                          extra=config.PKI_INDENTATION_LEVEL_0)
-    config.pki_log.debug(pkilogging.format(config.pki_master_dict),
+    config.pki_log.debug(pkilogging.format(parser.pki_master_dict),
                          extra=config.PKI_INDENTATION_LEVEL_0)
 
     print "Uninstalling " + config.pki_subsystem + " from " + deployed_pki_instance_path + "."
 
     # Process the various "scriptlets" to remove the specified PKI subsystem.
-    pki_subsystem_scriptlets = config.pki_master_dict['destroy_scriplets'].split()
+    pki_subsystem_scriptlets = parser.pki_master_dict['destroy_scriplets'].split()
+    deployer = util.PKIDeployer(parser.pki_master_dict)
     rv = 0
     for pki_scriptlet in pki_subsystem_scriptlets:
         scriptlet = __import__("pki.deployment." +
                                pki_scriptlet,
                                fromlist = [pki_scriptlet])
         instance = scriptlet.PkiScriptlet()
-        rv = instance.destroy()
+        rv = instance.destroy(deployer)
         if rv != 0:
             sys.exit(1)
     config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
                          extra=config.PKI_INDENTATION_LEVEL_0)
-    config.pki_log.debug(pkilogging.format(config.pki_master_dict),
+    config.pki_log.debug(pkilogging.format(parser.pki_master_dict),
                          extra=config.PKI_INDENTATION_LEVEL_0)
 
     print
diff --git a/base/server/src/pkispawn b/base/server/src/pkispawn
index b05db476000e7b51dc29506c24aaff6697705b51..78726ea709ecb4266c1229d43a4c1445585db199 100755
--- a/base/server/src/pkispawn
+++ b/base/server/src/pkispawn
@@ -44,6 +44,7 @@ try:
     from pki.deployment.pkiparser import PKIConfigParser
     from pki.deployment import pkilogging
     from pki.deployment import pkimessages as log
+    import pki.deployment.pkihelper as util
 except ImportError:
     print >> sys.stderr, """\
 There was a problem importing one of the required Python modules. The
@@ -161,7 +162,7 @@ def main(argv):
             parser.set_property(config.pki_subsystem, 'pki_client_database_password', admin_password)
             parser.set_property(config.pki_subsystem, 'pki_client_pkcs12_password', admin_password)
 
-            if config.pki_master_dict['pki_import_admin_cert'] == 'True':
+            if parser.pki_master_dict['pki_import_admin_cert'] == 'True':
                 import_cert = 'Y'
             else:
                 import_cert = 'N'
@@ -312,27 +313,27 @@ def main(argv):
     parser.compose_pki_slots_dictionary()
     config.pki_log.debug(log.PKI_DICTIONARY_SLOTS,
                          extra=config.PKI_INDENTATION_LEVEL_0)
-    config.pki_log.debug(pkilogging.format(config.pki_slots_dict),
+    config.pki_log.debug(pkilogging.format(parser.pki_slots_dict),
                          extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Combine the various sectional dictionaries into a PKI master dictionary
     parser.compose_pki_master_dictionary()
 
-    config.pki_master_dict['pki_spawn_log'] = config.pki_log_dir + "/" + \
+    parser.pki_master_dict['pki_spawn_log'] = config.pki_log_dir + "/" + \
                                               config.pki_log_name
     config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
                          extra=config.PKI_INDENTATION_LEVEL_0)
-    config.pki_log.debug(pkilogging.format(config.pki_master_dict),
+    config.pki_log.debug(pkilogging.format(parser.pki_master_dict),
                          extra=config.PKI_INDENTATION_LEVEL_0)
 
     if not interactive and\
-        not config.str2bool(config.pki_master_dict['pki_skip_configuration']):
+        not config.str2bool(parser.pki_master_dict['pki_skip_configuration']):
         try:
             parser.ds_connect()
             parser.ds_bind()
 
             if parser.ds_base_dn_exists() and\
-                not config.str2bool(config.pki_master_dict['pki_ds_remove_data']):
+                not config.str2bool(parser.pki_master_dict['pki_ds_remove_data']):
                 print 'ERROR:  Base DN already exists.'
                 sys.exit(1)
 
@@ -343,8 +344,8 @@ def main(argv):
             sys.exit(1)
 
         if config.pki_subsystem != "CA" or\
-            config.str2bool(config.pki_master_dict['pki_clone']) or\
-            config.str2bool(config.pki_master_dict['pki_subordinate']):
+            config.str2bool(parser.pki_master_dict['pki_clone']) or\
+            config.str2bool(parser.pki_master_dict['pki_subordinate']):
             try:
                 parser.sd_connect()
                 info = parser.sd_get_info()
@@ -359,10 +360,11 @@ def main(argv):
                 print('ERROR:  Unable to access security domain: ' + str(e))
                 sys.exit(1)
 
-    print "Installing " + config.pki_subsystem + " into " + config.pki_master_dict['pki_instance_path'] + "."
+    print "Installing " + config.pki_subsystem + " into " + parser.pki_master_dict['pki_instance_path'] + "."
 
     # Process the various "scriptlets" to create the specified PKI subsystem.
-    pki_subsystem_scriptlets = config.pki_master_dict['spawn_scriplets'].split()
+    pki_subsystem_scriptlets = parser.pki_master_dict['spawn_scriplets'].split()
+    deployer = util.PKIDeployer(parser.pki_master_dict, parser.pki_slots_dict)
     rv = 0
     for pki_scriptlet in pki_subsystem_scriptlets:
         scriptlet = __import__("pki.deployment." +
@@ -370,7 +372,7 @@ def main(argv):
                                fromlist=[pki_scriptlet])
         instance = scriptlet.PkiScriptlet()
         try:
-            rv = instance.spawn()
+            rv = instance.spawn(deployer)
         except:
             log_error_details()
             print
@@ -378,33 +380,34 @@ def main(argv):
             print
             sys.exit(1)
         if rv != 0:
+            print "Nothing here!!!"
             print "Installation failed."
             sys.exit(1)
     config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
                          extra=config.PKI_INDENTATION_LEVEL_0)
-    config.pki_log.debug(pkilogging.format(config.pki_master_dict),
+    config.pki_log.debug(pkilogging.format(parser.pki_master_dict),
                          extra=config.PKI_INDENTATION_LEVEL_0)
 
-    print_install_information()
+    print_install_information(parser.pki_master_dict)
 
-def print_install_information():
+def print_install_information(pki_master_dict):
 
-    skip_configuration = config.str2bool(config.pki_master_dict['pki_skip_configuration'])
+    skip_configuration = config.str2bool(pki_master_dict['pki_skip_configuration'])
     print log.PKI_SPAWN_INFORMATION_HEADER
     if skip_configuration:
-        print log.PKI_CONFIGURATION_URL_1 % config.pki_master_dict['pki_configuration_url']
+        print log.PKI_CONFIGURATION_URL_1 % pki_master_dict['pki_configuration_url']
         print
         print log.PKI_CONFIGURATION_RESTART_1 % \
-              config.pki_master_dict['pki_registry_initscript_command']
+              pki_master_dict['pki_registry_initscript_command']
     else:
-        print "    Admin username: %s" % config.pki_master_dict['pki_admin_uid']
-        if not config.str2bool(config.pki_master_dict['pki_client_database_purge']):
-            print "    Location of client database: %s" % config.pki_master_dict['pki_client_database_dir']
-        print "    Client certificate nickname: %s" % config.pki_master_dict['pki_admin_nickname']
-        print log.PKI_CHECK_STATUS_MESSAGE % config.pki_master_dict['pki_instance_name']
-        print log.PKI_INSTANCE_RESTART_MESSAGE % config.pki_master_dict['pki_instance_name']
-        print log.PKI_ACCESS_URL % (config.pki_master_dict['pki_hostname'],
-                                    config.pki_master_dict['pki_https_port'],
+        print "    Admin username: %s" % pki_master_dict['pki_admin_uid']
+        if not config.str2bool(pki_master_dict['pki_client_database_purge']):
+            print "    Location of client database: %s" % pki_master_dict['pki_client_database_dir']
+        print "    Client certificate nickname: %s" % pki_master_dict['pki_admin_nickname']
+        print log.PKI_CHECK_STATUS_MESSAGE % pki_master_dict['pki_instance_name']
+        print log.PKI_INSTANCE_RESTART_MESSAGE % pki_master_dict['pki_instance_name']
+        print log.PKI_ACCESS_URL % (pki_master_dict['pki_hostname'],
+                                    pki_master_dict['pki_https_port'],
                                     config.pki_subsystem.lower())
     print log.PKI_SPAWN_INFORMATION_FOOTER
 
